<?
/* Statystyki rchtb ver 0.2 zciech 
Umiescic w katalogu www, zmienic nazwe na htb.php
Wymaga Apacza z obsluga php */
$iface_inet = "imq0";
$iface_local = "imq1";
?>
<HTML>
<HEAD>
<TITLE>Statystyki rchtb</TITLE>
<META HTTP-EQUIV="Refresh" CONTENT="20; URL=htb.php">
<STYLE TYPE="text/css">
BODY { background-color: #ddd; color: #000; }
TD { font-size: 12pt;}
TR.sum { background-color: #fdd; }
TR.odd { background-color: #dfe; }
TR.even { background-color: #dee; }
</STYLE>  
</HEAD>
<BODY>
<p align=center><b><font color=#000080 face=Verdana>Statystyka ruchu rchtb<BR>NND Linux Router</font></b></p><center>
<?

function tcparse ($output, $flow) {
    global $transfer;
    $classes = explode("\n\n", $output);
    foreach ($classes as $class) {
	$lines = explode("\n",$class);
        $l = 0;
        $rate = "";
	foreach ($lines as $line) {
    	    if ($l!=0 && preg_match("/rate (.*?) /", $line, $matches)) {
        	$rate = $matches[1];
    	    }
    	    $l++;
	}
	if ($rate!="" && preg_match("/class htb 2:(.*?) /", $lines[0], $matches))
	{
	    $classid=$matches[1];
	    if (preg_match("/(.*?)bit/", $rate, $vrate)) {
		$rate = floor(($vrate[1]) / 1024)." kbit/s";
	    }
	    if ($rate != "0 kbit/s") {
		if ($classid > 2000) {
		    $classid=$classid-2000;
		    $transfer[$classid][$flow."p2p"] = $rate;		
		}else if ($classid > 1000) {
		    $classid=$classid-1000;
		    $transfer[$classid][$flow."normal"] = $rate;
		}else{
		    $transfer[$classid]["classid"] = $classid;
		    $transfer[$classid][$flow] = $rate;
		}
	    }
	}
        if ($rate!="" && preg_match("/class htb 1:(.*?) /", $lines[0], $matches))
        {
            $classid=$matches[1];
            if (preg_match("/(.*?)bit/", $rate, $vrate)) {
                $rate = floor(($vrate[1]) / 1024)." kbit/s";
            }
            if ($rate != "0 kbit/s") {
                if ($classid > 2000) {
                    $classid=$classid-2000;
                    $transfer[$classid][$flow."p2p"] = $rate;
                }else if ($classid > 1000) {
                    $classid=$classid-1000;
                    $transfer[$classid][$flow."normal"] = $rate;
                }else{

                    $transfer[$classid]["classid"] = $classid;
	            $transfer[$classid][$flow] = $rate;
		}    
            }
        }

    }    
}

$eup = `tc -s -d class show dev $iface_inet`;
tcparse($eup, "ul");
$edw = `tc -s -d class show dev $iface_local`;
tcparse($edw, "dl");
$grupa = 0;
$ipki = `awk 'sub("^[ \t]*","") && /^[0123456789G]/ {print $1" "$2}' /etc/rchtb/htb.hosts`;
$ipeki = explode("\n", $ipki);
$l = 11;

foreach ($ipeki as $ipek) {
    if ( substr($ipek, 0, 5) == "GRUP ") { 
	$grupa = 1;
	$l1=$l+1000;
	$l2=$l+2000;
	$transfer[$l]["ipek"] = "Grupa ".substr($ipek, 5);
	$transfer[$l1]["ipek"] = "Normal - Grupa ".substr($ipek, 5);
	$transfer[$l2]["ipek"] = "<b>P2P - Grupa ".substr($ipek, 5)."</b>";
	$l++;
	continue;
    }
    if (substr($ipek, 0, 4) == "GRUP") {
	$grupa = 0;
	continue;
    }
    if ($grupa == 0) {
        $l1=$l+1000;
	$l2=$l+2000;
	$transfer[$l]["ipek"] = $ipek;
	$transfer[$l1]["ipek"] = "Normal -". $ipek;
	$transfer[$l2]["ipek"] = "<b>P2P - ".$ipek."</b>";
	$l++;
    }	
}	

ksort($transfer);
?>
<center>
<table border=1 cellspacing=1 cellpadding=2>
<tr class="even"><td rowspan="2">&nbsp </td><td style="text-align: center"; colspan="3"> Download </td><td style="text-align: center"; colspan="3"> Upload </td></tr>
<tr class="even"><td style="text-align: center">Suma</td><td style="text-align: center">Normal</td><td style="text-align: center">P2P</td><td style="text-align: center">Suma</td><td style="text-align: center">Normal</td><td style="text-align: center">P2P</td></tr>
<?
$i = 1;

foreach ($transfer as $class) {
    switch ($class["classid"]) {
    case 1:
        $name = $iface_local."/".$iface_inet;
        break;
    case 2:
        $name = "Internet/ACK";
        break;
    case 3:
        $name = "Serwer/Goscie";
        break;
    case 4:
        $name = "ICMP";
        break;
    case 5:
        $name = "p2p";
        break;
    case 6:
        $name = "WWW - PORT 80, 443";
        break;
    default:
	if ($class["ipek"] != "")
	{$name = $class["ipek"];} else {$name = $class["classid"];}
    }
    if ($class["dl"] != "" || $class["ul"] != "") {
        ?><tr class="<?
	if ($class["classid"]<10) {
	    echo "sum";
        } else if ($i%2) {
	    echo "odd";
	} else {
	    echo "even";
	}
	if ($class["dl"] == "") {
	    $class["dl"]="&nbsp";
	}
	if ($class["ul"] == "") {
	    $class["ul"]="&nbsp";
	}
        if ($class["dlnormal"] == "") {
            $class["dlnormal"]="&nbsp";
        }
        if ($class["ulnormal"] == "") {
            $class["ulnormal"]="&nbsp";
        }
        if ($class["dlp2p"] == "") {
            $class["dlp2p"]="&nbsp";
        }
        if ($class["ulp2p"] == "") {
            $class["ulp2p"]="&nbsp";
        }
			    
	?>"><td> <?=$name ?></td><td align=right> <?=$class["dl"]?> </td><td align=right> <?=$class["dlnormal"]?> </td><td align=right> <?=$class["dlp2p"]?> </td><td align=right> <?=$class["ul"]?> </td><td align=right> <?=$class["ulnormal"]?> </td><td align=right> <?=$class["ulp2p"]?> </td></tr>
<?
	$i++;
   }
}
?>
</center></table>
<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0><TR VALIGN=top>
<TD WIDTH=200 ALIGN=LEFT><FONT FACE="Arial,Helvetica" SIZE=2>version 0.2-07.02.17 dla rchtb 0.2x</FONT></TD>
<TD WIDTH=250 ALIGN=RIGHT><FONT FACE="Arial,Helvetica" SIZE=2>
<A HREF="mailto:zciech@wp.pl">&lt;Zciech&gt;</A>
<A HREF="http://reliserv.pl/nnd">&lt;http://reliserv.pl/nnd&gt;</A></TD>
</TR><tr>
<td WIDTH=200>&nbsp</td>
<td WIDTH=250 ALIGN=RIGHT><A HREF="http://nnd.freesco.pl/">NND Linux Router</a> </td></tr>
</CENTER><br>
</body>
<?
/*
Srypt ten jest  przerobionym i dostosowanym  do rchtb 0.2x by zciech 
skryptem staystyk z pakietu obwman 
http://okon.one.pl/downloads/files/obwman/obwman.zip

Oryginalna licencja:
-------------------------------------------------------------------------------
Copyright (c) 2004, Michal "ok0n" Kubski
All rights reserved.

This Software may be copied or redistributed as long as it is not sold
for profit, and it cannot be incorporated into any other substantive
product with or without modifications for profit or non-profit. If The 
Software is modified, it must include the following notices:

  - The Software is not the original (for protection of the original
      author's reputations from any problems introduced by others)
      
        - Change history (e.g. date, functionality, etc.)
	
	This copyright notice must be reproduced on each copy made.
	
	Neither the name of the Author nor the name of The Software
	may be used to endorse or promote products derived from
	this software without specific prior written permission.
	
	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
	AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
	ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
	LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
	CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
	SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
	INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
	CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
	POSSIBILITY OF SUCH DAMAGE.
-------------------------------------------------------------------------------
*/
?>	
	


